/**************************************************************/
/*                                                            */
/*  apsse.c                                                   */
/*                                                            */
/*  Copyright(c) 2003 NISHIDA Kyousuke All rights reserved.   */
/*  This is free software, and the license is BSD.            */
/*                                                            */
/*  Version : 2. 3. 0                                         */
/*                                                            */
/*  Last Update : 2003. 5. 29                                 */
/*                                                            */
/**************************************************************/

#define _APSSE_VALUE_DEFINE_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "apsse.h"
#include "httpc.h"

int main(int argc, char **argv)
{

  /* ̓t@C */
  char input_filename[MAX_CHAR];

  /* o̓t@C */
  char output_filename[MAX_CHAR];

  /* symbol.txt烍[hp */
  char symbols[MAX_CHAR];

  /* ZNV */
  char sec_name[MAX_CHAR];

  /* tmpȊ */
  char s_tmp[MAX_CHAR], s_tmp2[MAX_CHAR];
  char s_dic_e[MAX_CHAR], s_dic_j[MAX_CHAR];
  char s_index[MAX_CHAR];
  char s_hint[MAX_CHAR];
  char url[MAX_CHAR];
 
  /* ̓t@C̊gqO */
  char input_title[MAX_CHAR];

  /* ZNV擾ptmp */
  char sec_title[MAX_CHAR], s_time[MAX_CHAR];

  /* p̃tO */
  int loop_flag, crlf_flag = F, middle_index_flag = F;
  int out_flag = T;

  /* '\0'ړ邽߂̕ϐCCR+LFȂ2CLFCCRȂ1ɂȂ */
  int re2 = 1;

  /* strleňʊi[p */
  int len_t2, len_e, len_j, len_tmp, len_e_re, len_sym;

  /* t@C̈ʒuw */
  long int offset;

  /* timer */
  time_t now;

  /* JE^Co͖萔 */
  int i, k, t;

  /* make_tmpfileōŏItmpt@C */
  FILE *fp_tmp;

  /* o̓t@C */
  FILE *fp_out;

  /* o͗ptmpt@CC_uo͂Ȃ */
  FILE *fp_tmp2;

  /* np`FbN */
  char *mem;

  /* t@C */
  FILE *fp_dict[DIC_MAX];

  /* t@C̉sR[h */
  int re_d[DIC_MAX];

  /* t@C */
  char dict_filename[DIC_MAX][MAX_CHAR];

  /* ̃CfbNXC t@CɂCs̐擪 */
  /* ꂼ0x20`0x7Ëʒui[ */
  long int dic_index[DIC_MAX][95];

  /* ԈvpCfbNXt@C */
  FILE *fp_index[DIC_MAX];

  /* 쌠 */
  char author[MAX_CHAR];


  /* WebURL */
  FILE *fp_webdict;
  char webdict_url[DIC_MAX][3][MAX_CHAR];
  int webdict_n = 1;
  int w_re = 1;

  /* Web wav */
  FILE *fp_webwav;
  char webwav_url[2][MAX_CHAR];

  /* html label */
  FILE *fp_label;
  char label[6][MAX_CHAR];  

  /* IvVw擾 */
  get_option(argc, argv, input_filename, output_filename,
      dict_filename, fp_dict);

  if (d == 0) {
    dict_check(fp_dict, dict_filename);
  }

  if (d == 0) {
    fprintf(stderr, "t@C܂D");
    fflush(stderr);
    exit(EXIT_DIC_FILE_OPEN);
  }

  /* ̓t@Cw肳Ȃ */
  if ((input_flag == F) && (stdin_flag == F)) {
    fprintf(stderr,
	"P𒊏ot@C or URL ͂ĂD\n -> ");
    fflush(stderr);
    fscanf(stdin, "%s", input_filename);
    input_flag = T;
  }

  /* _E[ĥ݂Ȃ̂URLȂ */
  if (download_flag == T) {
    if (!strstr(input_filename, "http://")) {
      fprintf(stderr, "_E[hɎs܂D\n");
      fflush(stderr);
      exit(EXIT_HTTPC);
    }
  }

  /* ͂ƂURL󂯎 */
  if (strstr(input_filename, "http://")) {
    if (download_flag == F) {
      strcpy(url, input_filename);
      if (httpc(url, input_filename, F) == 1) {
	fprintf(stderr, "_E[hɎs܂D\n");
	fflush(stderr);
	exit(EXIT_HTTPC);
      } else {
	http_flag = T;
      }
    } else {
      strcpy(url, input_filename);
      if (httpc(url, output_filename, output_flag) == 1) {
	fprintf(stderr, "_E[hɎs܂D\n");
	fflush(stderr);
	exit(EXIT_HTTPC);
      } else {
	fprintf(stderr, "\"%s\"ɕۑ܂D\n", output_filename);
	fflush(stderr);
	fprintf(stderr, "apsseI܂.\n");
	return 0;
      }
    }
  }

  /* gȂ[h */
  if (nodict_flag == T) {
    if (search_flag != T_WORD) {
      search_flag = T_WORD;
      idiom_flag = F;
    }
    if (format_flag == PSSDB5S) {
      format_flag = HTML_OUT;
    }
    replace_flag = F;
  }

  /* o̓t@Cw肳Ȃ */
  if ((output_flag == F) && (stdout_flag == F)) {
    if (input_flag == T) {
      get_file_title(input_filename, input_title);
      if (format_flag == PSSDB5S) {
	sprintf(output_filename, "%s.pssdb5s", input_title);
      } else if (format_flag == CSV) {
	sprintf(output_filename, "%s.csv", input_title);
      } else if ((format_flag == HTML_OUT) ||
		 (format_flag == HTML_OUT2)){
	sprintf(output_filename, "%s_out.html", input_title);
      }
    } else {
      /* -Iw肳ꂽꍇ */
      if (format_flag == PSSDB5S)
	sprintf(output_filename, DEF_PSSDB5S_FILE);
      else if (format_flag == CSV)
	sprintf(output_filename, DEF_CSV_FILE);
      else if ((format_flag == HTML_OUT) ||
		 (format_flag == HTML_OUT2))
	sprintf(output_filename, DEF_HTML_FILE);
    }
  }

  /* t@C̉sR[h`FbN & G[ */
  for (i = 0; i < d; i++) {
    re_d[i] = crlf_check(fp_dict[i]);
    if (re_d[i] == 0) {
      fprintf(stderr, "t@C\"%s\"̉sR[h",
	  dict_filename[i]);
      fprintf(stderr, "CR+LFLFɕϊĂD\n");
      exit(EXIT_DIC_CR);
    }
  }

  /* symbol.txt̋LsymbolsɃ[h */
  len_sym = 0;
  load_symbol(symbols);
  len_sym = strlen(symbols);

  /* Web̐ݒ */
  if ((format_flag == HTML_OUT) ||
      (format_flag == HTML_OUT2)) {

    if ((fp_webdict = fopen(WEBDICT_FILE, "r")) == 0) {
      perror(WEBDICT_FILE);
      exit(EXIT_WEBDICT_FILE_OPEN);
    }
    w_re = crlf_check(fp_webdict);
    for (i = 0; i < DIC_MAX; i++) {

      if ((format_flag == HTML_OUT2) &&
	  (i == 1))
	break;

      if (fgets(webdict_url[i][0], MAX_CHAR, fp_webdict) == NULL) 
	break;
      webdict_url[i][0][strlen(webdict_url[i][0]) - w_re] = '\0';
      fgets(webdict_url[i][1], MAX_CHAR, fp_webdict);
      webdict_url[i][1][strlen(webdict_url[i][1]) - w_re] = '\0';
      fgets(webdict_url[i][2], MAX_CHAR, fp_webdict);
      webdict_url[i][2][strlen(webdict_url[i][2]) - w_re] = '\0';
      
    }

    webdict_n = i;

    fclose(fp_webdict);

    if ((fp_webwav = fopen(WEBWAV_FILE, "r")) == 0) {
      perror(WEBWAV_FILE);
      exit(EXIT_WEBWAV_FILE_OPEN);
    }
    w_re = crlf_check(fp_webwav);

    fgets(webwav_url[0], MAX_CHAR, fp_webwav);
    webwav_url[0][strlen(webwav_url[0]) - w_re] = '\0';
    fgets(webwav_url[1], MAX_CHAR, fp_webwav);
    webwav_url[1][strlen(webwav_url[1]) - w_re] = '\0';

    fclose(fp_webwav);

    if ((fp_label = fopen(LABEL_FILE, "r")) == 0) {
      perror(LABEL_FILE);
      exit(EXIT_LABEL_FILE_OPEN);
    }
    w_re = crlf_check(fp_label);

    for (i = 0; i < 6; i++) {
      fgets(label[i], MAX_CHAR, fp_label);
      label[i][strlen(label[i]) - w_re] = '\0';
    }

    fclose(fp_label);

    
  }

  if (search_flag == T_WORD) {
    /* PȂ */

    if (sort_dic_flag == T) {
      /* \[gāCfp_dicɎ擾CsR[h */
      for (i = 0; i < d; i++) {
	fp_dict[i] =
	    sort_dictionary(fp_dict[i], dict_filename[i], re_d[i]);
	re_d[d] = crlf_check(fp_dict[i]);
      }
    }

    /* t@C̃CfbNX쐬 */
    for (i = 0; i < d; i++) {
      make_dic_index(fp_dict[i], dic_index[i], T);
    }

  } else {
    /* nȂ */

    /* ԈvpCfbNXfp_indexɎ擾 */
    for (i = 0; i < d; i++) {
      fp_index[i] = make_mid_index(fp_dict[i], dict_filename[i], symbols);
    }

    /* ԈvpCfbNXt@C̃CfbNX쐬 */
    for (i = 0; i < d; i++) {
      make_dic_index(fp_index[i], dic_index[i], T);
    }
  }

  /* tmpt@C̓t@C쐬fp_tmpɎ擾 */
  fp_tmp = make_tmpfile(input_filename, symbols);

  fprintf(stderr, "\"%s\"ɏo͂Jn܂...\n", output_filename);
  fflush(stderr);

  /* o̓t@CI[v */

  if (stdout_flag == F) {
    if ((fp_out = fopen(output_filename, "w+")) == NULL) {
      perror(output_filename);
      exit(EXIT_OUTPUT_FILE_OPEN);
    }
  } else {
    fp_out = stdout;
  }

  /* ̓t@C擾(Ō'/'ȍ~擾) */
  get_file_name(input_filename, sec_title);

  /* sƂ̎Ԏ擾 */
  time(&now);
  strftime(s_time, MAX_CHAR, "%a %b %d %H.%M.%S %Y", localtime(&now));

  /* ZNV̏o */
  sprintf(sec_name, "%s (%s)", sec_title, s_time);

  /* 쌠Җ̍쐬 */
  get_file_name(dict_filename[0], s_tmp);
  get_file_title(s_tmp, author);
  for (i = 1; i < d; i++) {
    get_file_name(dict_filename[1], s_tmp);
    get_file_title(s_tmp, s_tmp2);
    sprintf(s_tmp, ", %s", s_tmp2);
    strcat(author, s_tmp);
  }

  if (format_flag == PSSDB5S) {
    /* pssdb5s̃wb_o */
    fprintf(fp_out, "# DatabaseVersion=5.0\n");
    fprintf(fp_out, "# PssEditor SectionExportFile (.pssdb5s) v3\n");
    fprintf(fp_out, "# path = << W >>/%s\n", sec_name);
    fprintf(fp_out,
	"#\n<s2>\n%s\n%s\n%s\n\nnote=%s\nnote=%s\n.\n", sec_name,
	author, EDITOR, NOTE1, NOTE2);

  } else if (format_flag == CSV) {
    fprintf(fp_out, "psscsvfile,100\n");
    fprintf(fp_out, "\"%s\",\"%s\",\"%s\",\n", sec_name, author, EDITOR);
    fprintf(fp_out, "\"%s\",%s\n", NOTE1, NOTE2);
    fprintf(fp_out, "a1,q1,h1\n");

  } else if ((format_flag == HTML_OUT) ||
	     (format_flag == HTML_OUT2)) {

    html_header_write(fp_out, sec_name, author, label);

  }

  /* o͗ptmpt@C̃I[v */
  if ((fp_tmp2 = fopen(OUT_TMP_FILE, "w+")) == NULL) {
    perror(OUT_TMP_FILE);
    exit(EXIT_TMP_FILE_OPEN);
  }

  /* nȂPڂtmpt@C */
  if (idiom_flag == T) {
    mem = file2memory(TMP_FILE);
  } else {
    mem = NULL;
  }

  /* o͖萔0ɃZbg */
  i = 0;

  if (search_flag != T_WORD) {
    /* nȂ */

    /* s_tmpɍŏItmpt@C璊oP1擾 */
    while (fscanf(fp_tmp, "%s", s_tmp) != EOF) {

      /* 擾 */
      len_tmp = strlen(s_tmp);

      for (t = 0; t < d; t++) {

	/* ԗpCfbNXŁCŏs_tmp[0]n܂sɈړ */
	fseek(fp_index[t], dic_index[t][s_tmp[0] - ' '], SEEK_SET);

	/* FɂĂ */
	middle_index_flag = F;

	/* s_indexɒԗpCfbNX1P擾 */
	while (fscanf(fp_index[t], "%s", s_index) != EOF) {

	  /* ƑȂC1ڂ̔r */
	  if (s_index[0] > s_tmp[0]) {
	    break;
	  }

	  /* s_index̎t@Cɂʒu擾 */
	  fscanf(fp_index[t], "%ld", &offset);

	  /* s_indexs_tmp */
	  if (strcmp(s_index, s_tmp) != 0) {

	    /* ꂪTȂC񓙂ȂňႤ̂ɂȂĂ */
	    /* ꂪFȂC܂ȂƂȂ */
	    if (middle_index_flag == T)
	      break;
	    else
	      continue;

	  } else {
	    /* ȂTɂĂ */
	    middle_index_flag = T;
	  }

	  /* Ƃ͎t@Cs_indexĂʒuɈړ */
	  fseek(fp_dict[t], offset, SEEK_SET);

	  /* (p)C({)ꂼeCjɎ擾 */
	  fgets(s_dic_e, MAX_CHAR, fp_dict[t]);
	  fgets(s_dic_j, MAX_CHAR, fp_dict[t]);

	  /* 𓚂̒擾C'\0'炷 */
	  len_e = strlen(s_dic_e);
	  len_e_re = len_e - re_d[t];
	  s_dic_e[len_e_re] = '\0';

	  /* 𓚂̕钷蒷Ȃ */
	  /* o̓t@Cɂ͏o͂Ȃ */
	  if (len_e_re >= ignore_long_length)
	    continue;

	  /* ̒擾C'\0'炷 */
	  len_j = strlen(s_dic_j);
	  s_dic_j[len_j - re_d[t]] = '\0';

	  /* symbols̓eƉpƃXy[XȊO܂܂Ă */
	  /* o̓t@Cɂ͏o͂Ȃ */
	  if (en_check(s_dic_e, symbols) != 0) {
	    continue;
	  }

	  /* o͗ptmpt@C̉sR[h`FbN */
	  /* ̃t@Cɉ܂Ăcrlf_flagTɂȂ */
	  if (crlf_flag == F) {
	    rewind(fp_tmp2);
	    re2 = crlf_check(fp_tmp2);
	    if (re2 != -1) {
	      crlf_flag = T;
	    }
	  }

	  /* o͗ptmpt@Cgďd`FbN */
	  loop_flag = F;
	  rewind(fp_tmp2);
	  /* o͗ptmpt@Cs_tmp2ɉ(p)擾 */
	  while (fgets(s_tmp2, MAX_CHAR, fp_tmp2) != NULL) {

	    /* 𓚂̒擾C'\0'炷 */
	    len_t2 = strlen(s_tmp2);
	    s_tmp2[len_t2 - re2] = '\0';

	    /* s_tmp2s_dic_edȂ̂ */
	    /* loop_flagT */
	    if (strcmp(s_tmp2, s_dic_e) == 0) {
	      loop_flag = T;
	      break;
	    }

	  }

	  /* loop_flagTȂdɂȂ̂ŏo̓t@Cɏo͂Ȃ */
	  if (loop_flag != F) {
	    continue;
	  }

	  /* Ƃ肠o͂ݒŏn`FbNJn */
	  out_flag = T;

	  /* Xy[X(p)̒ɂ邩ǂ */
	  for (k = 0; k < len_e_re; k++) {
	    if (s_dic_e[k] == ' ')
	      break;
	  }

	  /* ȂnꂶȂ */
	  if (k != len_e_re) {
	    /* ̓t@Cs_dic_e܂܂Ă邩ǂ */

	    if (idiomcheck(mem, s_dic_e) != 0) {
	      out_flag = F;
	    }

	  } else {
	    /* P̏ꍇȂ̂ */
	    if (idiom_only_flag == T) {
	      out_flag = F;
	    }

	  }

	  if (out_flag == T) {

	    /* o͗ptmpt@Cɉ(p)o */
	    fprintf(fp_tmp2, "%s\n", s_dic_e);

	    /* ƃqgɕ */
	    ja2hint(s_dic_j, s_hint);

	    if (cut_flag == T) {
	      s_dic_j[cut_length] = ' ';
	      s_dic_j[cut_length + 1] = ' ';
	      s_dic_j[cut_length + 2] = '\0';
	    }

	    /* o̓t@Cɏo */
	    question_output(fp_out, s_dic_e, s_dic_j, s_hint, 
			    webdict_url, webwav_url, label, webdict_n);

	    /* o͖萔̃JEg */
	    i++;

	    /* MESSAGE_TIMEo͂Wo͂ɃbZ[W */
	    if (i % MESSAGE_TIME == 0) {
	      fprintf(stderr, "*");
	      fflush(stderr);
	    }

	  }

	}
      }
    }


  } else {
    /* PȂ */

    /* s_tmpɍŏItmpt@C璊oP1擾 */
    while (fscanf(fp_tmp, "%s", s_tmp) != EOF) {

      out_flag = F;
      for (t = 0; t < d; t++) {

	/* t@CŁCŏs_tmp[0]n܂sɈړ */
	rewind(fp_dict[t]);
	fseek(fp_dict[t], dic_index[t][s_tmp[0] - ' '], SEEK_SET);

	/* s_dic_eɎt@C(p)1s擾 */
	while (fgets(s_dic_e, MAX_CHAR, fp_dict[t]) != NULL) {

	  /* ƑȂC1ڂ̔r */
	  if (s_dic_e[0] > s_tmp[0]) {
	    break;
	  }

	  /* s_dic_jɎt@C({)1s擾 */
	  fgets(s_dic_j, MAX_CHAR, fp_dict[t]);


	  /* 𓚂̒擾C'\0'炷 */
	  len_e = strlen(s_dic_e);
	  len_e_re = len_e - re_d[t];
	  s_dic_e[len_e_re] = '\0';

	  /* 𓚂̕钷蒷Ȃ */
	  /* o̓t@Cɂ͏o͂Ȃ */
	  if (len_e_re >= ignore_long_length)
	    continue;

	  /* symbols̓eƉpƃXy[XȊO܂܂Ă */
	  /* o̓t@Cɂ͏o͂Ȃ */
	  if (en_check(s_dic_e, symbols) != 0) {
	    continue;
	  }

	  /* s_dic_es_tmpႤȂ */
	  /* o̓t@Cɂ͏o͂Ȃ */
	  if (strcmp(s_tmp, s_dic_e) != 0) {
	    continue;
	  }

	  /* o͗ptmpt@C̉sR[h`FbN */
	  /* ̃t@Cɉ܂Ăcrlf_flagTɂȂ */
	  if (crlf_flag == F) {
	    rewind(fp_tmp2);
	    re2 = crlf_check(fp_tmp2);
	    if (re2 != -1) {
	      crlf_flag = T;
	    }
	  }

	  /* o͗ptmpt@Cgďd`FbNJn */
	  loop_flag = F;
	  rewind(fp_tmp2);

	  /* o͗ptmpt@Cs_tmp2ɉ(p)擾 */
	  while (fgets(s_tmp2, MAX_CHAR, fp_tmp2) != NULL) {

	    /* 𓚂̒擾C'\0'炷 */
	    len_t2 = strlen(s_tmp2);
	    s_tmp2[len_t2 - re2] = '\0';

	    /* s_tmp2s_dic_edȂ̂ */
	    /* loop_flagT */
	    if (strcmp(s_tmp2, s_dic_e) == 0) {
	      loop_flag = T;
	      break;
	    }

	  }

	  /* loop_flagTȂdɂȂ̂ŏo̓t@Cɏo͂Ȃ */
	  if (loop_flag != F) {
	    continue;
	  }

	  /* ̒擾C'\0'炷 */
	  len_j = strlen(s_dic_j);
	  s_dic_j[len_j - re_d[t]] = '\0';

	  /* o͗ptmpt@Cɉ(p)o */
	  fprintf(fp_tmp2, "%s\n", s_dic_e);

	  /* ƃqgɕ */
	  ja2hint(s_dic_j, s_hint);

	  if (cut_flag == T) {
	    s_dic_j[cut_length] = ' ';
	    s_dic_j[cut_length + 1] = ' ';
	    s_dic_j[cut_length + 2] = '\0';
	  }

	  /* o̓t@Cɏo */
	  question_output(fp_out, s_dic_e, s_dic_j, s_hint, 
			  webdict_url, webwav_url, label, webdict_n);

	  /* o͂ */
	  out_flag = T;

	  /* o͖萔̃JEg */
	  i++;

	  /* MESSAGE_TIMEo͂Wo͂ɃbZ[W */
	  if (i % MESSAGE_TIME == 0) {
	    fprintf(stderr, "*");
	    fflush(stderr);
	  }

	  /* TKv͖ */
	  t = d;
	  break;
	}
      }

      /* o͂ĂȂ & nodictȂ */
      if ((out_flag == F) && (nodict_flag == T)) {
	strcpy(s_dic_j, "");
	strcpy(s_hint, "");
	question_output(fp_out, s_tmp, s_dic_j, s_hint, 
			webdict_url, webwav_url, label, webdict_n);
	i++;
	if (i % MESSAGE_TIME == 0) {
	  fprintf(stderr, "*");
	  fflush(stderr);
	}
      }
      

    }
  }

  /* o̓t@CɃZNV̏IĂƂ */
  if (format_flag == PSSDB5S) {
    fprintf(fp_out, "</s2>\n");
  } else if ((format_flag == HTML_OUT) ||
	     (format_flag == HTML_OUT2)) {
    fprintf(fp_out, "</tbody></table>\n");
    fprintf(fp_out, "<hr class=\"b\">\n");
    fprintf(fp_out, "<div class=\"note\">%s</div>\n", NOTE1);
    fprintf(fp_out, "<div>%s</div>\n", NOTE2);
    fprintf(fp_out, "</body>\n</html>\n");
  }

  fprintf(stderr, "\n - %do͂܂.\n", i);
  fflush(stderr);

  /* -qw肳ꂽo̓t@C牽₩oĖW */
  if (question_flag == T) {
    select_question(fp_out, output_filename, i, sec_title, s_time, author, label);
  }

  /* t@CN[Y */
  fclose(fp_tmp);
  for (i = 0; i < d; i++)
    fclose(fp_dict[i]);
  if (fp_out != stdout)
    fclose(fp_out);
  fclose(fp_tmp2);
  if (search_flag != T_WORD) {
    for (i = 0; i < d; i++) {
      fclose(fp_index[i]);
    }
  }
  if (idiom_flag == T) {
    free(mem);
  }

  fprintf(stderr, "ꎞt@C폜Ă܂...\n");
  fflush(stderr);

  /* tmpt@C폜 */

  remove(TMP_FILE);
  remove(TMP_FILE2);
  remove(TMP_FILE3);
  remove(TMP_FILE4);

  remove(OUT_TMP_FILE);
  if (http_flag == T) {
    remove(input_filename);
  }

  fprintf(stderr, "apsseI܂.\n");

  return 0;
}

/* s(pCXy[XCsymbols̓e)ȊOCAXy[X */
/* ܂܂Ă邩ǂCȂ-1CȂȂ0 */
int en_check(const char *s, const char *symbols)
{

  int space_flag = F;
  int i, len = strlen(symbols);

  for (; *s != '\0'; s++) {
    /* ƃXy[XsymbolsȊÕ`FbN */
    if ((islower((unsigned char) *s) == 0) && (*s != ' ')) {
      for (i = 0; i < len; i++) {
	if (*s == symbols[i]) {
	  break;
	}
      }
      /* ꂪ^ȂC*s͉płXy[Xłsymbols̓ełȂ */
      if (i == len)
	return -1;
    }

    /* AXy[X̃`FbN */
    if (*s == ' ') {
      switch (space_flag) {
      case T:
	/* AXy[XĂƂȂ̂-1Ԃ */
	return -1;
	break;
      case F:
	/* Xy[XTɂ */
	space_flag = T;
      default:
	break;
      }
    } else {
      /* Xy[XȂȂFɂĂ */
      space_flag = F;
    }
  }

  /* ɂȂȂ0Ԃ */
  return 0;
}

/* ̓t@CP𒊏otmpt@C쐬 */
/* ŏItmpt@CԂ */
FILE *make_tmpfile(const char *filename, const char *symbols)
{

  /* ̓t@C */
  FILE *fp_org;

  /* tmpt@C1`4 */
  FILE *fp_tmp, *fp_tmp2, *fp_tmp3, *fp_tmp4;

  /* ignore.txt, replace.txt */
  FILE *fp_ig, *fp_rp;

  /* tmpȊ */
  char s1[MAX_CHAR], s2[MAX_CHAR], tmp[MAX_CHAR];
  WORDS *word;

  /* replace.txtł̒uOCu */
  char r1[MAX_CHAR], r2[MAX_CHAR];

  /* 낢 */
  int len_tmp, len_s1, len_s2, len_r1, len_r2, len_sym;

  /* ̑ */
  int c, loop_flag;
  int i, j, k, re;
  long int offset;

  /* ̓t@CI[v */
  if (stdin_flag == F) {
    if ((fp_org = fopen(filename, "r")) == NULL) {
      perror(filename);
      exit(EXIT_INPUT_FILE_OPEN);
    }
  } else {
    fp_org = stdin;
  }

  fprintf(stderr, "ꎞt@C쐬Jn܂...\n");
  fflush(stderr);

  /* tmpt@C1`4I[v */
  if ((fp_tmp = fopen(TMP_FILE, "w+")) == NULL) {
    perror(TMP_FILE);
    exit(EXIT_TMP_FILE_OPEN);
  }

  if ((fp_tmp2 = fopen(TMP_FILE2, "w+")) == NULL) {
    perror(TMP_FILE2);
    exit(EXIT_TMP_FILE_OPEN);
  }

  if ((fp_tmp3 = fopen(TMP_FILE3, "w+")) == NULL) {
    perror(TMP_FILE3);
    exit(EXIT_TMP_FILE_OPEN);
  }

  if ((fp_tmp4 = fopen(TMP_FILE4, "w+")) == NULL) {
    perror(TMP_FILE4);
    exit(EXIT_TMP_FILE_OPEN);
  }

  /* ignore.txtI[v */
  fp_ig = NULL;
  if (ignore_flag == T) {
    if ((fp_ig = fopen(IGNORE_FILE, "r")) == NULL) {
      perror(IGNORE_FILE);
      exit(EXIT_IGNORE_FILE_OPEN);
    }
  }

  /* replace.txtI[v */
  fp_rp = NULL;
  if (replace_flag == T) {
    if ((fp_rp = fopen(REPLACE_FILE, "r")) == NULL) {
      perror(REPLACE_FILE);
      exit(EXIT_REPLACE_FILE_OPEN);
    }
  }

  /* symbol.txtɉL邩`FbN */
  len_sym = strlen(symbols);

  /* fp_tmp֓̓t@CL̂o͊Jn */

  while ((c = fgetc(fp_org)) != EOF) {

    /* -HHTMLwȂ */
    if (text_flag == HTML) {

      /* ^O */
      if (c == '<') {
	do {
	  c = fgetc(fp_org);
	}
	while ((c != '>') && (c != EOF));
      }

      /* &quot; Ƃ &lt; 𖳎 */

      if (c == '&') {
	offset = ftell(fp_org);
	do {
	  c = fgetc(fp_org);
	}
	while ((c != ';') && (c != EOF) && (c != ' '));
	if ((c == EOF) || (c == ' ')) {
	  fseek(fp_org, offset, SEEK_SET);
	}
      }

    }

    if ((isalpha((unsigned char) c) == 0) ||
	(isspace((unsigned char) c) != 0)) {
      for (i = 0; i < len_sym; i++) {
	if (c == symbols[i]) {
	  break;
	}
      }

      /* ꂪ^ȂCc͉płXy[Xłsymbols̓ełȂ */
      if (i == len_sym)
	c = ' ';
    }

    if (nodict_flag == F) {
      if (isupper(c))
	c = tolower(c);
    }

    /* fp_tmpɏo */
    fputc(c, fp_tmp);

  }

  /* fp_tmp2fp_tmp𐮌`́replace.txtŒûo͊Jn */

  rewind(fp_tmp);
  k = 0;

  /* fp_tmps11Pǂ݂Ƃ */
  while (fscanf(fp_tmp, "%s", s1) != EOF) {

    /* 擾 */
    len_s1 = strlen(s1);

    /* fp_tmp2s1o */
    fprintf(fp_tmp2, "%s\n", s1);
    k++;

    /* replace.txtŒuȂȂ玟̒PɈڂ */
    if (replace_flag != T) {
      continue;
    }

    rewind(fp_rp);

    /* sR[h`FbN */
    re = crlf_check(fp_rp);

    /* fp_rps21s擾 */
    while (fgets(s2, MAX_CHAR, fp_rp) != NULL) {

      /* s2̒擾, '\0'炷 */
      len_s2 = strlen(s2) - re;
      s2[len_s2] = '\0';

      /* s2uOr1ƒur2擾 */
      sscanf(s2, "%s %s", r1, r2);

      /* r1̒擾 */
      len_r1 = strlen(r1);

      /* ss2ɒuOr1Ȃr2NULLɂĂ */
      if (len_s2 == len_r1) {
	r2[0] = '\0';
      }

      /* r2̒擾 */
      len_r2 = strlen(r2);

      /* s1̒-r1̒="s1̖r1߂ʒu"擾 */
      len_tmp = len_s1 - len_r1;

      /* u邩ǂ`FbN */
      for (i = len_tmp, j = 0; s1[i] != '\0'; i++, j++) {
	if (s1[i] != r1[j]) {
	  break;
	}
      }

      /* r1̓es1̖Ɋ܂܂ĂȂ̂ŒuȂ */
      if (j != len_r1) {
	continue;
      }

      /* s1̖r1r2ɒutmp */
      strcpy(tmp, s1);
      strcpy(&tmp[len_tmp], r2);

      /* tmpfp_tmp2ɏo */
      fprintf(fp_tmp2, "%s\n", tmp);
      k++;

    }
  }

  /* tmp2\[g */

  if (nodict_flag == F) {

    /* fp_tmp2ɏo͂̃m */
    word = (WORDS *) malloc(sizeof(WORDS) * k);
    
    /* fp_tmp2ǂݍ */
    i = 0;
    rewind(fp_tmp2);
    while (fscanf(fp_tmp2, "%s", word[i++].s) != EOF);
    
    /* \[g */
    qsort((void *) word, (size_t) k, sizeof(WORDS),
	  (int (*)(const void *, const void *)) words_cmp);
    
    /* \[go */
    i = 0;
    
    fclose(fp_tmp2);
    remove(TMP_FILE2);
    if ((fp_tmp2 = fopen(TMP_FILE2, "w+")) == NULL) {
      perror(TMP_FILE2);
      exit(EXIT_TMP_FILE_OPEN);
    }
    
    for (i = 0; i < k; i++)
      fprintf(fp_tmp2, "%s\n", word[i].s);
    
    free(word);

  }

  /* fp_tmp3fp_tmp2ignore.txtŖ̂o͊Jn */

  rewind(fp_tmp2);

  /* fp_tmp2P1s1Ɏ擾 */
  while (fscanf(fp_tmp2, "%s", s1) != EOF) {

    /* s1̒擾 */
    len_s1 = strlen(s1);

    loop_flag = F;

    /* ignore.txtŖȂ */
    if (ignore_flag == T) {

      /* Zs1Ȃ */
      if (ignore_short_length < len_s1) {

	/* ignore.txts1܂܂Ă邩`FbN */
	rewind(fp_ig);

	while (fscanf(fp_ig, "%s", s2) != EOF) {

	  /* s1s2Ȃ疳 */
	  if (strcmp(s1, s2) == 0) {
	    loop_flag = T;
	    break;
	  }

	}

	/* ZȂ疳 */
      } else {
	loop_flag = T;
      }

    }

    /* ꂪPȂfp_tmp3ɂ͏o͂Ȃ */
    if (loop_flag != F) {
      continue;
    }

    /* ȂPȂfp_tmp3ɏo */
    fprintf(fp_tmp3, "%s\n", s1);


  }

  /* fp_tmp4fp_tmp3ŏdĂ̂̂o͊Jn */

  rewind(fp_tmp3);

  /* fp_tmp3P1s1Ɏ擾 */
  while (fscanf(fp_tmp3, "%s", s1) != EOF) {

    /* fp_tmp4s1ǂ`FbN */
    rewind(fp_tmp4);
    loop_flag = F;
    while (fscanf(fp_tmp4, "%s", s2) != EOF) {

      /* s1s2ȂĂ */
      if (strcmp(s1, s2) == 0) {
	loop_flag = T;
	break;
      }

    }

    /* ܂ĂȂȂfp_tmp4̖ɏo */
    if (loop_flag == F) {
      fseek(fp_tmp4, 0, SEEK_END);
      fprintf(fp_tmp4, "%s\n", s1);
    }

  }

  /* t@CN[Y */
  if (fp_org != stdin)
    fclose(fp_org);
  fclose(fp_tmp);
  fclose(fp_tmp2);
  fclose(fp_tmp3);
  if (ignore_flag == T)
    fclose(fp_ig);
  if (replace_flag == T)
    fclose(fp_rp);

  rewind(fp_tmp4);

  /* ŏItmpt@C^[ */
  return fp_tmp4;

}

/* t@C̃CfbNX */
void make_dic_index(FILE * fp_dic, long int *dic_index, int flag)
{

  char ch, s_dic[MAX_CHAR];
  long int offset;

  rewind(fp_dic);

  /* ŏ̓Xy[X(0x20) */
  ch = ' ';

  /* t@C̈ʒu0 */
  offset = 0;

  /* t@C1ss_dicɓǂݍ */
  while (fgets(s_dic, MAX_CHAR, fp_dic) != NULL) {

    /* s_dic̐擪ch傫ȂCchn܂s͎ɂȂĂ */
    /* Ȃ̂őOs_dic̃t@Cʒucĥ̂ƂĂ */
    while (s_dic[0] > ch) {
      dic_index[ch - ' '] = offset;
      ch++;
    }

    /* s_dic̐擪chȂC̍s̃t@C̈ʒudic_indexɋL */
    /* ch͎̕ɂ */
    if (s_dic[0] == ch) {
      dic_index[ch - ' '] = offset;
      ch++;
    }

    /* ({)̓ǂݔ΂ */
    if (flag == T)
      fgets(s_dic, MAX_CHAR, fp_dic);

    /* offsetɃt@C̈ʒu擾 */
    offset = ftell(fp_dic);
  }

  /* ŌɃ`_(0x7E)܂ŊmF */
  while (ch <= '~') {
    dic_index[ch - ' '] = offset;
    ch++;
  }

}

/* symbol.txt̓ǂݍ */
void load_symbol(char *symbols)
{
  int i;
  FILE *fp_sym;

  /* symbol.txtI[v */
  if ((fp_sym = fopen(SYMBOL_FILE, "r")) == NULL) {
    perror(SYMBOL_FILE);
    exit(EXIT_SYMBOL_FILE_OPEN);
  }

  /* symbol.txt1('\r''\n'͖)ǂݍ */
  for (i = 0; (symbols[i] = (char) fgetc(fp_sym)) != EOF; i++) {
    if (symbols[i] == '\r' || symbols[i] == '\n')
      i--;
  }

  /* '\0'Ƃ */
  symbols[i] = '\0';

  /* t@CN[Y */
  fclose(fp_sym);

}

/* fp̃t@C̉sR[h̃`FbN */
/* CR+LFȂ2CLFȂ1CCRȂ0Ԃ */
int crlf_check(FILE * fp)
{
  char s[MAX_CHAR];
  long int offset;
  int len, re;

  /* fp̃t@Cʒuwq̌ݒnޔ */
  offset = ftell(fp);

  /* fpɂȂ-1Ԃ */
  rewind(fp);
  if (fgets(s, MAX_CHAR, fp) == NULL)
    return -1;

  /* s̒擾 */
  len = strlen(s);


  if (s[len - CR_LF] == '\r') {
    /* 2O'\r'Ȃ */
    re = CR_LF;
  } else {
    if (s[len - LF] == '\n') {
      /* 1O'\n'Ȃ */
      re = LF;
    } else {
      /* ȂȂ */
      re = CR;
    }
  }

  /* fp̏ꏊɖ߂ */
  fseek(fp, offset, SEEK_SET);

  /* reԂ */
  return re;

}

/* IvV̎擾 */
void get_option(int argc, char **argv, char *input_filename,
		char *output_filename, char dict_filename[][MAX_CHAR], 
		FILE ** fp_dict) {
  

  int i, j, err_flag = F;
  char s_tmp[MAX_CHAR], s_tmp2[MAX_CHAR], s_tmp3[MAX_CHAR];
  FILE *fp_buf;

  i = 1;
  if (argc > 1) {
    if (argv[1][0] != '-') {
      input_flag = T;
      yen2slash(argv[1], input_filename);
      i++;
    }
  }

  // option: iodrTHtjJnNSlLqIOpcDCvhxXy

  for (; i < argc; i++) {

    if ((strcmp(argv[i], "-i") == 0) || 
	(strcmp(argv[i], "--input") == 0)) {
      /* ̓t@C̎w */

      input_flag = T;
      if (((i + 1) < argc) && (argv[i + 1][0] != '-')) {
	strcpy(input_filename, argv[++i]);
      } else {
	err_flag = T;
	break;
      }

    } else if ((strcmp(argv[i], "-o") == 0) ||
	(strcmp(argv[i], "--output") == 0)) {
      /* o̓t@C̎w */
      output_flag = T;
      if (((i + 1) < argc) && (argv[i + 1][0] != '-')) {
	strcpy(output_filename, argv[++i]);
      } else {
	err_flag = T;
	break;
      }

    } else if ((strcmp(argv[i], "-d") == 0) ||
	(strcmp(argv[i], "--dictionary") == 0)) {
      /* t@C̎w */

      if (((i + 1) < argc) && (argv[i + 1][0] != '-')) {

	if (d == 0)
	  dict_check(fp_dict, dict_filename);

	strcpy(s_tmp, argv[++i]);

	if ((fp_buf = fopen(s_tmp, "r")) == NULL) {
	  fprintf(stderr, "\"%s\"܂D\n", s_tmp);
	  fflush(stderr);
	} else {

	  if (d == DIC_MAX) {
	    fprintf(stderr, "wo鎫̐%d܂łłD\n", DIC_MAX);
	    fflush(stderr);
	    break;
	  }

	  get_file_name(s_tmp, s_tmp2);
	  for (j = 0; j < d; j++) {
	    get_file_name(dict_filename[j], s_tmp3);
	    if (strcmp(s_tmp3, s_tmp2) == 0) {
	      fprintf(stderr,
		  "\"%s\"͎%dƂĊɎw肳Ă܂D\n", s_tmp2,
		  j);
	      fflush(stderr);
	      break;
	    }
	  }
	  if (j == d) {
	    fp_dict[d] = fp_buf;
	    strcpy(dict_filename[d], s_tmp);
	    fprintf(stderr, "\"%s\"%dƂĎgp܂D\n",
		s_tmp, d);
	    fflush(stderr);
	    d++;
	  }

	}

      } else {
	err_flag = T;
	break;
      }

    } else if ((strcmp(argv[i], "-T") == 0) ||
	(strcmp(argv[i], "--text") == 0)) {
      /* ̓t@Č`eLXg */
      text_flag = TEXT;

    } else if ((strcmp(argv[i], "-H") == 0) ||
	(strcmp(argv[i], "--html") == 0)) {
      /* ̓t@Č`HTML */
      text_flag = HTML;

    } else if ((strcmp(argv[i], "-t") == 0) ||
	(strcmp(argv[i], "--word") == 0)) {
      /* Pꂾ */
      search_flag = T_WORD;
      idiom_flag = F;

    } else if ((strcmp(argv[i], "-j") == 0) ||
	(strcmp(argv[i], "--word-idiom") == 0)) {
      /* PƏn */
      search_flag = WORD_IDIOM;
      idiom_flag = T;

    } else if ((strcmp(argv[i], "-J") == 0) ||
	(strcmp(argv[i], "--idiom") == 0)) {
      /* nꂾ */
      search_flag = IDIOM;
      idiom_flag = T;
      idiom_only_flag = T;

    } else if ((strcmp(argv[i], "-n") == 0) ||
	(strcmp(argv[i], "--no-ignore") == 0)) {
      /* ignore.txtŖȂ */
      ignore_flag = F;
      ignore_short_length = 0;
      ignore_long_length = MAX_CHAR;

    } else if ((strcmp(argv[i], "-N") == 0) ||
	(strcmp(argv[i], "--no-replace") == 0)) {
      /* replaqce.txtŒuȂ */
      replace_flag = F;

    } else if ((strcmp(argv[i], "-S") == 0) ||
	(strcmp(argv[i], "--sort-directory") == 0)) {
      /* \[gĂg */
      sort_dic_flag = T;

    } else if ((strcmp(argv[i], "-l") == 0) ||
	(strcmp(argv[i], "--ignore-short-length") == 0)) {

      /* Z̐ݒ */
      if (((i + 1) < argc) && (argv[i + 1][0] != '-') &&
	  (isdigit((unsigned char) argv[i + 1][0]) != 0)) {
	ignore_short_length = atoi(argv[++i]);
      } else {
	err_flag = T;
	break;
      }
      /* G[`FbN */
      if ((ignore_short_length < 0) || (ignore_short_length > MAX_CHAR)) {
	fprintf(stderr, "%s : 0%d܂ł̐w肵Ă.\n",
	    argv[i], MAX_CHAR);
	exit(EXIT_OPTION);
      }

    } else if ((strcmp(argv[i], "-L") == 0) ||
	(strcmp(argv[i], "--ignore-long-length") == 0)) {

      /* 钷̐ݒ */
      if (((i + 1) < argc) && (argv[i + 1][0] != '-') &&
	  (isdigit((unsigned char) argv[i + 1][0]) != 0)) {
	ignore_long_length = atoi(argv[++i]);
      } else {
	err_flag = T;
	break;
      }
      /* G[`FbN */
      if ((ignore_long_length < 0) || (ignore_long_length > MAX_CHAR)) {
	fprintf(stderr, "%s : 0%d܂ł̐w肵Ă.\n",
	    argv[i], MAX_CHAR);
	exit(EXIT_OPTION);
      }

    } else if ((strcmp(argv[i], "-q") == 0) ||
	(strcmp(argv[i], "--question") == 0)) {
      /* o͖萔̐ݒ */

      /* w肵 */
      if (((i + 1) < argc) && (argv[i + 1][0] != '-')) {
	if (isdigit((unsigned char) argv[i + 1][0]) != 0) {
	  question_num = atoi(argv[++i]);
	} else {
	  err_flag = T;
	  break;
	}
      }

      /* G[`FbN */
      if (question_num < 0) {
	fprintf(stderr, "%s : 0ȏ̐w肵Ă.\n", argv[i]);
	exit(EXIT_OPTION);
      }
      question_flag = T;

    } else if ((strcmp(argv[i], "-I") == 0) ||
	(strcmp(argv[i], "--stdin") == 0)) {
      /* W͂ */
      stdin_flag = T;
      strcpy(input_filename, "stdin");

    } else if ((strcmp(argv[i], "-O") == 0) ||
	(strcmp(argv[i], "--stdout") == 0)) {
      /* Wo͂ɏo */
      stdout_flag = T;
      strcpy(output_filename, "stdout");

    } else if ((strcmp(argv[i], "-p") == 0) ||
	(strcmp(argv[i], "--pssdb5s") == 0)) {
      /* pssdb5s`ŏo */
      format_flag = PSSDB5S;

    } else if ((strcmp(argv[i], "-c") == 0) ||
	(strcmp(argv[i], "--csv") == 0)) {
      /* csv`ŏo */
      format_flag = CSV;

    } else if ((strcmp(argv[i], "-x") == 0) ||
	(strcmp(argv[i], "--html-out-dic1") == 0)) {
      /* html`ŏo 1 */
      format_flag = HTML_OUT2;

    } else if ((strcmp(argv[i], "-X") == 0) ||
	(strcmp(argv[i], "--html-out-dics") == 0)) {
      /* html`ŏo  */
      format_flag = HTML_OUT;

    } else if ((strcmp(argv[i], "-D") == 0) ||
	(strcmp(argv[i], "--download") == 0)) {
      /* csv`ŏo */
      download_flag = T;

    } else if ((strcmp(argv[i], "-y") == 0) ||
	(strcmp(argv[i], "--no-dictionary") == 0)) {
      /* gȂI */
      nodict_flag = T;

    } else if ((strcmp(argv[i], "-C") == 0) ||
	(strcmp(argv[i], "--cut") == 0)) {
      /* csv`ŏo */

      /* w肵 */
      if (((i + 1) < argc) && (argv[i + 1][0] != '-')) {
	if (isdigit((unsigned char) argv[i + 1][0]) != 0) {
	  cut_length = atoi(argv[++i]);
	} else {
	  err_flag = T;
	  break;
	}
      }

      /* G[`FbN */
      if ((cut_length < 0) || (cut_length > (MAX_CHAR - 1))) {
	fprintf(stderr, "%s : 0%d܂ł̐w肵Ă.\n",
	    argv[i], (MAX_CHAR - 1));
	exit(EXIT_OPTION);
      }

      cut_flag = T;

    } else if ((strcmp(argv[i], "-v") == 0) ||
	(strcmp(argv[i], "--version") == 0)) {
      fprintf(stderr, "Version %s\n", VERSION);
      exit(EXIT_OPTION);

    } else if ((strcmp(argv[i], "-h") == 0) ||
	(strcmp(argv[i], "--help") == 0)) {
      /* wv̕\ */
      show_help();
    } else {
      show_help();
    }

  }

  if (err_flag == T)
    show_help();

}

/* ԈvpCfbNXt@C̍쐬 */
FILE *make_mid_index(FILE * fp_dic, const char *dic_filename,
    const char *symbols)
{
  /* CfbNXt@Ctmpt@C */
  FILE *fp_index, *fp_tmp;

  /* CfbNXt@CƂ̖O֘A */
  char dic_index_filename[MAX_CHAR];
  char dic_title[MAX_CHAR], dic_name[MAX_CHAR];

  /* tmpȊ */
  char s_dic[MAX_CHAR], buf[MAX_CHAR];
  WORDS *tmp;

  /* ̑ */
  int i, j, k, h, len, len_sym = strlen(symbols);
  int re = crlf_check(fp_dic);
  long int offset;

  /* t@C̊gq̑O̖O(geneƂ)dic_titleɎ擾 */
  get_file_name(dic_filename, dic_name);
  get_file_title(dic_name, dic_title);

  /* o̓t@Cdic_index_filename */
  sprintf(dic_index_filename, "%s%s.index.txt", DICT_DIR, dic_title);

  /* dic_index_filename݂Ȃ炻g */
  if ((fp_index = fopen(dic_index_filename, "r")) != NULL) {
    fprintf(stderr, "o͍ς݂̃CfbNX");
    fprintf(stderr, "t@C\"%s\"gp܂.\n", dic_index_filename);
    fflush(stderr);
    return fp_index;

    /* dic_index_filename݂ȂȂn߂ */
  } else {

    fprintf(stderr, "t@C̃CfbNXt@C");
    fprintf(stderr, "\"%s\"ɏo͂܂...\n", dic_index_filename);
    fflush(stderr);

    /* CfbNXt@C̃I[v */
    if ((fp_index = fopen(dic_index_filename, "w+")) == NULL) {
      perror(dic_index_filename);
      exit(EXIT_TMP_FILE_OPEN);
    }

    /* tmpt@CI[v */
    if ((fp_tmp = fopen(DIC_INDEX_TMP_FILE, "w+")) == NULL) {
      perror(DIC_INDEX_TMP_FILE);
      exit(EXIT_TMP_FILE_OPEN);
    }

    /* t@C擪 */
    rewind(fp_dic);
    offset = 0;

    /* o̓JEg */
    k = 0;

    /* s_dic1sǂݍ */
    while (fgets(s_dic, MAX_CHAR, fp_dic) != NULL) {

      /* 擾C'\0'炷 */
      len = strlen(s_dic) - re;
      s_dic[len] = '\0';

      /* P̒0 */
      j = 0;

      for (i = 0; i <= len; i++) {
	/* Xy[X'\0'ŒP؂ */
	if ((s_dic[i] == ' ') || (s_dic[i] == '\0')) {

	  /* '\0'ĒPƎ̈ʒutmpt@Cɏo */
	  if (j > 0) {
	    buf[j] = '\0';
	    fprintf(fp_tmp, "%s\n%ld\n", buf, offset);
	    k++;
	  }

	  /* P̒0 */
	  j = 0;

	} else if (!islower((unsigned char) s_dic[i])) {
	  /* P̒ɏȊO玟̋؂蕶܂œǂݔ΂ */
	  /* symbol.txtɏĂPƂĔF߂ */

	  for (h = 0; h < len_sym; h++) {
	    if (s_dic[i] == symbols[h]) {
	      buf[j++] = s_dic[i];
	      break;
	    }
	  }

	  if (h == len_sym) {

	    while (s_dic[i] != ' ' && s_dic[i] != '\0')
	      i++;
	    /* P̒0 */
	    j = 0;

	  }


	} else {
	  /* Ȃobt@ɃRs[ */
	  buf[j++] = s_dic[i];

	}
      }

      /* ({)̓ǂݔ΂ */
      fgets(s_dic, MAX_CHAR, fp_dic);

      /* ̈ʒuL */
      offset = ftell(fp_dic);
    }

    fprintf(stderr, "CfbNXt@Cɐ񂵂܂...\n");
    fflush(stderr);

    /* o͂Pꐔm */
    tmp = (WORDS *) malloc(sizeof(WORDS) * k);

    /* tmpt@C烁Ɋi[ */
    rewind(fp_tmp);
    k = 0;
    while (fscanf(fp_tmp, "%s", tmp[k].s) != EOF) {
      fscanf(fp_tmp, "%ld", &tmp[k].o);
      k++;
    }

    /* tmpt@CN[Y폜 */
    fclose(fp_tmp);
    remove(DIC_INDEX_TMP_FILE);

    /* \[g */
    qsort((void *) tmp, (size_t) k, sizeof(WORDS),
	(int (*)(const void *, const void *)) words_cmp);

    /* CfbNXt@Cɏo */
    for (i = 0; i < k; i++) {
      fprintf(fp_index, "%s\n%ld\n", tmp[i].s, tmp[i].o);
    }

    /*  */
    free(tmp);

    /* CfbNXt@C^[ */
    return fp_index;

  }

}

/* qsortp̔r֐ */
int words_cmp(WORDS * a1, WORDS * a2)
{
  return strcmp(a1->s, a2->s);
}

/* ̃\[g */
FILE *sort_dictionary(FILE * fp_dic, const char *dic_filename, int re)
{

  /* \[gt@C */
  FILE *fp_sort;

  /* \[gt@CƂ̖O֘A */
  char dic_sort_filename[MAX_CHAR];
  char dic_title[MAX_CHAR], dic_name[MAX_CHAR];

  /* tmpȊ */
  char s_dic[MAX_CHAR];
  DICT *tmp;

  /* ̑ */
  int k, len, i;


  /* t@C̊gq̑O̖O(geneƂ)dic_titleɎ擾 */
  get_file_name(dic_filename, dic_name);
  get_file_title(dic_name, dic_title);

  /* o̓t@Cdic_sort_filename */
  sprintf(dic_sort_filename, "%s%s.sort.txt", DICT_DIR, dic_title);

  /* dic_sort_filename݂Ȃ炻g */
  if ((fp_sort = fopen(dic_sort_filename, "r")) != NULL) {

    fprintf(stderr, "ɐς݂̎\"%s\"gp܂.\n",
	dic_sort_filename);
    fflush(stderr);
    return fp_sort;

    /* dic_sort_filename݂ȂȂn߂ */
  } else {

    fprintf(stderr, "t@Cɐ񂵂\"%s\"ɏo͂܂...\n",
	dic_sort_filename);
    fflush(stderr);

    /* \[gt@C̃I[v */
    if ((fp_sort = fopen(dic_sort_filename, "w+")) == NULL) {
      perror(dic_sort_filename);
      exit(EXIT_TMP_FILE_OPEN);
    }

    /* ̖Ɖ𓚂̑gg邩JEg */
    rewind(fp_dic);
    k = 0;
    while (fgets(s_dic, MAX_CHAR, fp_dic) != NULL) {
      fgets(s_dic, MAX_CHAR, fp_dic);
      k++;
    }

    /* ǧ̃m */
    tmp = (DICT *) malloc(sizeof(DICT) * k);


    rewind(fp_dic);
    i = 0;

    /* 1seɓǂݍ */
    while (fgets(tmp[i].e, MAX_CHAR, fp_dic) != NULL) {

      /* 擾C'\0'炷 */
      len = strlen(tmp[i].e);
      tmp[i].e[len - re] = '\0';

      /* ({)̓ǂݔ΂ */
      fgets(tmp[i].j, MAX_CHAR, fp_dic);

      /* 擾C'\0'炷 */
      len = strlen(tmp[i].j);
      tmp[i].j[len - re] = '\0';
      i++;
    }

    /* t@CN[Y */
    fclose(fp_dic);

    /* \[g */
    qsort((void *) tmp, (size_t) k, sizeof(DICT),
	(int (*)(const void *, const void *)) dict_cmp);

    /* \[ĝfp_sortɏo */
    for (i = 0; i < k; i++) {
      fprintf(fp_sort, "%s\n%s\n", tmp[i].e, tmp[i].j);
    }

    /*  */
    free(tmp);

    /* \[gt@C^[ */
    return fp_sort;

  }

}

/* qsortp̔r֐ */
int dict_cmp(DICT * a1, DICT * a2)
{
  return strcmp(a1->e, a2->e);
}

/* o̓t@CIďo */
void select_question(FILE * fp_out, const char *output_filename, int sum,
		     const char *sec_title, const char *s_time, 
		     const char *author, char label[][MAX_CHAR])
{

  /* question_num₾o͂t@C */
  FILE *fp_out_s;

  /* ̖O֘A */
  char out_subset_filename[MAX_CHAR];
  char output_title[MAX_CHAR];

  /* tmpȊ */
  char s_tmp[MAX_CHAR], s_dic_e[MAX_CHAR], s_dic_j[MAX_CHAR];
  int *number;
  char s_hint[MAX_CHAR];

  /* ZNV */
  char sec_name[MAX_CHAR];

  /* ̑ */
  int i, j, k;

  /* output_titleɏo̓t@C̊gqO擾 */
  get_file_title(output_filename, output_title);

  /* o̓t@C̖萔I萔ƍ̂Ń`FbN */
  if (sum < question_num) {
    question_num = sum;
  }

  /* out_subset_filenameɑIo̓t@C̖O */
  if (format_flag == PSSDB5S) {
    sprintf(out_subset_filename, "%s_sub_%d.pssdb5s",
	output_title, question_num);
  } else if (format_flag == CSV) {
    sprintf(out_subset_filename, "%s_sub_%d.csv",
	output_title, question_num);
  } else if ((format_flag == HTML_OUT) ||
	     (format_flag == HTML_OUT2)) {
    sprintf(out_subset_filename, "%s_sub_%d.html",
	output_title, question_num);

  }

  /* Io̓t@C̃I[v */
  if ((fp_out_s = fopen(out_subset_filename, "w")) == NULL) {
    perror(out_subset_filename);
    exit(EXIT_OUTPUT_FILE_OPEN);
  }

  fprintf(stderr, "o̓t@C%dI\"%s\"ɏo͂܂...\n",
      question_num, out_subset_filename);
  fflush(stderr);

  /* _̎ */
  srand((unsigned) time(NULL));

  /* I萔m */
  number = (int *) malloc(sizeof(int) * question_num);

  /* I萔̖ԍnumberɊl */
  for (j = 0; j < question_num; j++) {

    for (;;) {
      number[j] = rand() % sum;

      /* ԍɑI񂾂̂ǂ`FbN */
      for (i = j - 1; i >= 0; i--) {
	if (number[j] == number[i]) {
	  break;
	}
      }
      /* ܂I񂾂̂ȂȂ玟̔ԍI */
      if (i == -1)
	break;
    }

  }

  /* ԍ̃\[g */
  qsort((void *) number, (size_t) question_num, sizeof(int),
      (int (*)(const void *, const void *)) num_cmp);


  /* o̓t@Cwb_ǂݍŁCIo̓t@Cɏo */
  /* ZNV֘A͕ύX */
  sprintf(sec_name, "%s_%d (%s)", sec_title, question_num, s_time);

  rewind(fp_out);

  if (format_flag == PSSDB5S) {
    for (j = 0; j < 12; j++) {
      if (j == 2) {
	fgets(s_tmp, MAX_CHAR, fp_out);
	fprintf(fp_out_s, "# path = << W >>/%s\n", sec_name);
      } else if (j == 5) {
	fgets(s_tmp, MAX_CHAR, fp_out);
	fprintf(fp_out_s, "%s\n", sec_name);
      } else {
	fgets(s_tmp, MAX_CHAR, fp_out);
	fputs(s_tmp, fp_out_s);
      }
    }
  } else if (format_flag == CSV) {
    for (j = 0; j < 4; j++) {
      if (j == 1) {
	fgets(s_tmp, MAX_CHAR, fp_out);
	fprintf(fp_out_s, "\"%s\",\"%s\",\"%s\",,\n",
	    sec_name, author, EDITOR);
      } else {
	fgets(s_tmp, MAX_CHAR, fp_out);
	fputs(s_tmp, fp_out_s);
      }
    }
  } else if ((format_flag == HTML_OUT) ||
	     (format_flag == HTML_OUT2)) {

    html_header_write(fp_out_s, sec_name, author, label);

  }

  /* o̓t@CǂݍŁCIo̓t@Cɏo */
  if (format_flag == PSSDB5S) {
    for (j = 0, k = 0; j < sum; j++) {
      fgets(s_dic_e, MAX_CHAR, fp_out);	// en
      fgets(s_tmp, MAX_CHAR, fp_out);	// .
      fgets(s_dic_j, MAX_CHAR, fp_out);	// ja
      fgets(s_tmp, MAX_CHAR, fp_out);	// .
      fgets(s_hint, MAX_CHAR, fp_out);	// hint
      fgets(s_tmp, MAX_CHAR, fp_out);	// .
      fgets(s_tmp, MAX_CHAR, fp_out);	// 
      fgets(s_tmp, MAX_CHAR, fp_out);	// .
      fgets(s_tmp, MAX_CHAR, fp_out);	// ..
      if (number[k] == j) {
	fprintf(fp_out_s, "%s.\n%s.\n%s.\n\n.\n..\n",
	    s_dic_e, s_dic_j, s_hint);
	k++;
      }
    }
    fprintf(fp_out_s, "</s2>\n");

  } else if (format_flag == CSV) {
    for (j = 0, k = 0; j < sum; j++) {
      fgets(s_tmp, MAX_CHAR, fp_out);
      if (number[k] == j) {
	fputs(s_tmp, fp_out_s);
	k++;
      }
    }

  } else if ((format_flag == HTML_OUT) ||
	     (format_flag == HTML_OUT2)) {

    for (;;) {
      fgets(s_tmp, MAX_CHAR, fp_out);
      if (strstr(s_tmp, "<table summary=\"apsse's output\"><tbody>") != 0) {
	fgets(s_tmp, MAX_CHAR, fp_out);
	break;
      }
    }

    for (j = 0, k = 0; j < sum; j++) {
      fgets(s_tmp, MAX_CHAR, fp_out);
      if (number[k] == j) {
	fputs(s_tmp, fp_out_s);
	k++;
      }
    }
    fprintf(fp_out_s, "</tbody></table>\n");
    fprintf(fp_out_s, "<hr class=\"b\">\n");
    fprintf(fp_out_s, "<div class=\"note\">%s</div>\n", NOTE1);
    fprintf(fp_out_s, "<div>%s</div>\n", NOTE2);
    fprintf(fp_out_s, "</body>\n</html>\n");
  }

  /* t@CN[Y */
  fclose(fp_out_s);

}

/* qsortp̔r֐ */
int num_cmp(int *a1, int *a2)
{
  if (*a1 > *a2)
    return 1;
  else if (*a1 < *a2)
    return -1;
  else
    return 0;
}

/* Ō'.'̑O̕擾 */
void get_file_title(const char *filename, char *title)
{

  int i;
  int len = strlen(filename);

  for (i = len - 1; i >= 0; i--) {
    if (filename[i] == '.') {
      strcpy(title, filename);
      title[i] = '\0';
      break;
    }
  }

  if (i == -1) {
    strcpy(title, filename);
  }

}

/* Ō'/'ȍ~̕擾 */
void get_file_name(const char *s1, char *s2)
{

  int i, len = strlen(s1);

  for (i = len - 1; i >= 0; i--) {
    if (s1[i] == '/') {
      break;
    }
  }

  strcpy(s2, &s1[i + 1]);

}

/* {̍sqgɐ؂蕪 */
void ja2hint(char *ja, char *hint)
{
  /* " / "C""C""ȍ~͑SăqgƂ݂Ȃ */

  char buf[3];

  strcpy(hint, "");

  for (; *ja != '\0'; ja++) {
    if (*ja == '/') {
      if ((*(ja - 1) == ' ') && (*(ja + 1) == ' ')) {

	*(ja - 1) = '\0';

	for (ja += 2; *ja != '\0'; ja++, hint++) {
	  *hint = *ja;
	}
	*hint = '\0';
	break;
      }
    }

    buf[0] = *ja;
    buf[1] = *(ja + 1);
    buf[2] = '\0';

    if ((strcmp(buf, "") == 0) || (strcmp(buf, "") == 0)) {
      *ja = '\0';
      for (ja += 2; *ja != '\0'; ja++, hint++) {
	*hint = *ja;
      }
      *hint = '\0';
      break;
    }

  }


}

/* n`FbN */
int idiomcheck(const char *mem, const char *s)
{

  int i, j, k, h, l;
  char buf[MAX_CHAR];
  char *tmp;

  for (j = 0; mem[j] != EOF; j++) {

    for (i = 0, k = j; ; i++) {

      if (s[i] == '\0') {
	return 0;
      }

      if (mem[k] == EOF) {
	break;
      }

      if ((s[i] == '~') || (s[i] == 'A') || (s[i] == 'B') ||
	  (s[i] == 'C') || (s[i] == 'D')) {

	if (s[i + 1] != '\0') {

	  for (l = i + 1, h = 0; ; h++, l++) {
	    if ((s[l] == ' ') ||
		(s[l] == '\0')) {
	      if (l != (i + 1)) {
		buf[h] = '\0';
		break;
	      }
	    }
	    buf[h] = s[l];
	  }
	  
	  tmp = strstr(&mem[k], buf);
	  if (tmp == NULL) {
	    break;
	  } else {
	    while(1) {
	      if (tmp == &mem[k])
		break;
	      else
		k++;
	    }
	  }

	}

      } else {

	if (mem[k] != s[i]) {
	  break;
	}
	k++;

      }

    }

  }

  return -1;
}

/* t@CɃ[h */
char *file2memory(const char *filename)
{

  char *mem;
  int i, j;
  FILE *fp;

  if ((fp = fopen(filename, "r")) == NULL) {
    perror(filename);
    exit(EXIT_INPUT_FILE_OPEN);
  }

  mem = (char *) malloc(sizeof(char) * MAX_CHAR);

  for (i = 0, j = 1;; i++) {

    if ((mem[i] = (char) fgetc(fp)) == EOF)
      break;

    if ((i + 1) % MAX_CHAR == 0) {
      j++;
      mem = (char *) realloc((void *) mem, (size_t) (MAX_CHAR * j));
    }


  }

  fclose(fp);

  return mem;

}

/* wv\ďI */
void show_help()
{

  fprintf(stderr, "NAME\n");
  fprintf(stderr, "\tapsse - Automatic PSS Editor Version %s\n\n",
      VERSION);
  fprintf(stderr, "SYNOPSIS\n");
  fprintf(stderr, "\tapsse (FILE_NAME | URL) [OPTION]...\n");
  fprintf(stderr, "\tapsse [OPTION]...\n\n");
  fprintf(stderr, "DESCRIPTION\n");
  fprintf(stderr, "\t-i, --input (FILE_NAME | URL)\n");
  fprintf(stderr, "\t-o, --output FILE_NAME\n");
  fprintf(stderr, "\t-I, --stdin\n");
  fprintf(stderr, "\t-O, --stdout\n");
  fprintf(stderr, "\t-d, --dictionary FILENAME\n");
  fprintf(stderr, "\t-T, --text\n");
  fprintf(stderr, "\t-H, --html\n");
  fprintf(stderr, "\t-t, --word\n");
  fprintf(stderr, "\t-j, --word-idiom\n");
  fprintf(stderr, "\t-J, --idiom\n");
  fprintf(stderr, "\t-n, --no-ignore\n");
  fprintf(stderr, "\t-N, --no-replace\n");
  fprintf(stderr, "\t-y, --no-dictionary\n");
  fprintf(stderr, "\t-l, --ignore-short-length LENGTH\n");
  fprintf(stderr, "\t-L, --ignore-long-length LENGTH\n");
  fprintf(stderr, "\t-S, --sort-dictionary\n");
  fprintf(stderr, "\t-q, --question [NUMBER]\n");
  fprintf(stderr, "\t-p, --pssdb5s\n");
  fprintf(stderr, "\t-c, --csv\n");
  fprintf(stderr, "\t-x, --html-out-dic1\n");
  fprintf(stderr, "\t-X, --html-out-dics\n");
  fprintf(stderr, "\t-D, --download\n");
  fprintf(stderr, "\t-C, --cut [LENGTH]\n");
  fprintf(stderr, "\t-h, --help\n");
  fprintf(stderr, "\t-v, --version\n");

  fprintf(stderr, "\nCOPYRIGHT\n");
  fprintf(stderr, "\tCopyright(c) 2003 NISHIDA Kyousuke ");
  fprintf(stderr, "All rights reserved.\n");
  fprintf(stderr, "\tThis is free software, and the license is BSD.\n\n");

  fprintf(stderr, "SEE ALSO\n");
  fprintf(stderr, "\tManpage of apsse : ");
  fprintf(stderr, "<http://www.h5.dion.ne.jp/~kyoun/apsse.html>\n");
  fprintf(stderr, "\tP-Study System : <http://www.takke.jp>\n");


  exit(EXIT_OPTION);

}
void dict_check(FILE * fp_dict[], char dict_filename[][MAX_CHAR])
{

  char s_tmp[MAX_CHAR], s_tmp2[MAX_CHAR], s_tmp3[MAX_CHAR];
  FILE *fp_buf, *fp_dict_load;
  int re;
  int i;

  /* dict.txt Ŏw肳ꂽt@CI[v */
  fprintf(stderr, "gp鎫`FbNĂ܂...\n");
  fflush(stderr);
  if ((fp_dict_load = fopen(DICT_FILE, "r")) == NULL) {
    perror(DICT_FILE);
    getchar();
    exit(EXIT_DICT_FILE_OPEN);
  }
  re = crlf_check(fp_dict_load);

  while (fgets(s_tmp, MAX_CHAR, fp_dict_load) != NULL) {
    s_tmp[strlen(s_tmp) - re] = '\0';

    if ((fp_buf = fopen(s_tmp, "r")) == NULL) {
      fprintf(stderr, "\"%s\"܂D\n", s_tmp);
      fflush(stderr);
    } else {
      get_file_name(s_tmp, s_tmp2);
      for (i = 0; i < d; i++) {
	get_file_name(dict_filename[i], s_tmp3);
	if (strcmp(s_tmp3, s_tmp2) == 0) {
	  fprintf(stderr, "\"%s\"͎%dƂĊɎw肳Ă܂D\n",
	      s_tmp2, i);
	  fflush(stderr);
	  break;
	}
      }
      if (i == d) {
	fp_dict[d] = fp_buf;
	strcpy(dict_filename[d], s_tmp);
	fprintf(stderr, "\"%s\"%dƂĎgp܂D\n", s_tmp, d);
	fflush(stderr);
	d++;
      }
    }


  }

}
void yen2slash(const char *s1, char *s2) {

  int i, len;

  len = strlen(s1);

  for (i = 0; i < len; i++) {
    if (s1[i] == '\\') {
      s2[i] = '/';
    } else {
      s2[i] = s1[i];
    }
  }
  s2[i] = '\0';

}

void html_header_write(FILE *fp_out, const char *sec_name, 
		       const char *author, char label[][MAX_CHAR]) {

  FILE *fp_style;
  char s_tmp[MAX_CHAR];

  /* DOCTYPE - meta */
  fprintf(fp_out, "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n");
  fprintf(fp_out, "<html lang=\"ja\">\n<head>\n");
  fprintf(fp_out, "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=%s\">\n", CHARSET);
  fprintf(fp_out, "<meta http-equiv=\"Content-Style-Type\" content=\"text/css\">\n");
  if (format_flag == HTML_OUT)
    fprintf(fp_out, "<meta http-equiv=\"Content-Script-Type\" content=\"text/javascript\">\n");
  fprintf(fp_out, "<meta name=\"author\" content=\"%s\">\n", EDITOR);
  fprintf(fp_out, "<meta name=\"copyright\" content=\"%s\">\n", author);

  /* style */
  fprintf(fp_out, "<style type=\"text/css\">\n<!--\n");
  if ((fp_style = fopen(STYLE_SHEET, "r")) == NULL) {
    perror(STYLE_SHEET);
    exit(EXIT_STYLE_SHEET_OPEN);
  }
  while (fgets(s_tmp, MAX_CHAR, fp_style) != NULL) {
    fputs(s_tmp, fp_out);
  }
  fclose(fp_style);
  fprintf(fp_out, "\n-->\n</style>\n");
  
  /* title - body */
  fprintf(fp_out, "<title>%s</title>\n", sec_name);
  fprintf(fp_out, "</head>\n<body>\n");

  /* javascript */
  if (format_flag == HTML_OUT) {
    fprintf(fp_out, "<script type=\"text/javascript\">\n<!--\n");
    fprintf(fp_out, "function jump(sel) {\n");
    fprintf(fp_out, "  if (sel.options[sel.selectedIndex].value) {\n");
    fprintf(fp_out, "    window.open(sel.options[sel.selectedIndex].value);\n");
    fprintf(fp_out, "  }\n}\n// -->\n</script>\n");
    fprintf(fp_out, "<noscript><div>JavaScriptonɂWebIׂ悤ɂȂ܂D</div></noscript>\n");
  }


  fprintf(fp_out, "<h1>%s</h1>\n<hr class=\"t\">\n", sec_name);
  fprintf(fp_out, "<table summary=\"apsse's output\"><tbody>\n");
  fprintf(fp_out, "<tr><th class=\"e\" abbr=\"English\">%s</th>", label[0]);
  fprintf(fp_out, "<th class=\"v\" abbr=\"Voice\">%s</th>", label[4]);
  if (format_flag == HTML_OUT) 
    fprintf(fp_out, "<th class=\"d\" abbr=\"Dictionary\">%s</th>", label[2]);
  fprintf(fp_out, "<th class=\"j\" abbr=\"Japanese\">%s</th>", label[1]);
  fprintf(fp_out, "<th class=\"h\" abbr=\"Hint\">%s</th></tr>\n", label[3]);


}

void question_output(FILE *fp_out, 
		     const char *s_dic_e, const char *s_dic_j, 
		     const char *s_hint,
		     char webdict_url[][3][MAX_CHAR], 
		     char webwav_url[][MAX_CHAR],
		     char label[][MAX_CHAR],
		     int webdict_n) {

  int k;

  /* o̓t@Cɏo */
  if (format_flag == PSSDB5S) {
    fprintf(fp_out, "%s\n.\n%s\n.\n%s\n.\n\n.\n..\n", s_dic_e,
	    s_dic_j, s_hint);
  } else if (format_flag == CSV) {
    fprintf(fp_out, "\"%s\",\"%s\",\"%s\"\n", s_dic_e,
	    s_dic_j, s_hint);
    
  } else if (format_flag == HTML_OUT) {
    
    fprintf(fp_out, "<tr><td class=\"e\">%s</td>", s_dic_e);
    fprintf(fp_out, "<td class=\"v\"><a href=\"%s%s%s\">%s</a></td>",
	    webwav_url[0], s_dic_e, webwav_url[1], label[5]);
    
    fprintf(fp_out, "<td class=\"d\"><select onchange=\"jump(this)\" tabindex=\"1\">");
    fprintf(fp_out, "<option>-- Web Dictioanry --</option>");
    
    for (k = 0; k < webdict_n; k++) {
      fprintf(fp_out, "<option value=\"%s%s%s\">%s</option>", 
	      webdict_url[k][1], s_dic_e, webdict_url[k][2], 
	      webdict_url[k][0]);
    }
    fprintf(fp_out, "</select></td>");	    
    fprintf(fp_out, "<td class=\"j\">%s</td>", s_dic_j);
    fprintf(fp_out, "<td class=\"h\">%s</td></tr>\n", s_hint);
    
  } else if (format_flag == HTML_OUT2) {
    
    
    fprintf(fp_out, "<tr><td class=\"e\">");
    fprintf(fp_out, "<a href=\"%s%s%s\">%s</a></td>", 
	    webdict_url[0][1], s_dic_e, 
	    webdict_url[0][2], s_dic_e);
    fprintf(fp_out, "<td class=\"v\"><a href=\"%s%s%s\">%s</a></td>",
	    webwav_url[0], s_dic_e, webwav_url[1], label[5]);
    
    fprintf(fp_out, "<td class=\"j\">%s</td>", s_dic_j);
    fprintf(fp_out, "<td class=\"h\">%s</td></tr>\n", s_hint);
    
  }
	  
}
