#define _HTTPC_VALUE_DEFINE_

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>

#ifdef WIN32
#include <winsock2.h>
#else
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>
#endif

#include "apsse.h"
#include "httpc.h"

#ifndef	SOCKET
#define SOCKET int
#endif

int httpc(const char *url, char *output_filename, int flag)
{

  SOCKET s;
  struct hostent *servhost;
  struct sockaddr_in server;
  struct servent *service;
  char send_buf[MAX_CHAR];
  char host[MAX_CHAR] = "localhost";
  char path[MAX_CHAR] = "/";
  unsigned short int port = 80;
  char host_path[MAX_CHAR];
  char *p;
  char buf[MAX_CHAR];
  char buf2[MAX_CHAR];
  int read_size;
  FILE *fp;
  int i, len;


#ifdef WIN32
  WORD wVersionRequested;
  WSADATA wsaData;
  int err;
  wVersionRequested = MAKEWORD(2, 2);
  err = WSAStartup(wVersionRequested, &wsaData);
  if (err != 0) {
    fprintf(stderr, "WinSock gpł܂. \n");
    return 1;
  }
#endif

  if (strlen(url) > MAX_CHAR - 1) {
    fprintf(stderr, "w肵URL܂D\n");
    return 1;
  }

  if ((sscanf(url, "http://%s", host_path) != EOF) &&
      (strcmp(url, "http://") > 0)) {

    /* zXg̎擾 ŏɏoĂ'/'ȑOƈȌŕ */
    p = strchr(host_path, '/');
    if (p != NULL) {
      strcpy(path, p);
      *p = '\0';
      /* '/'Ohost */
      strcpy(host, host_path);
    } else {
      strcpy(host, host_path);
    }

    /* zXg̕ ":" ܂܂Ă */
    p = strchr(host, ':');
    if (p != NULL) {
      /* |[gԍ擾 p+1̐擪 */
      port = (unsigned short int) atoi(p + 1);
      if (port <= 0) {
	port = 80;
      }
      *p = '\0';
    }
  }

  fprintf(stderr, "\"http://%s%s\"̃_E[hJn܂...\n",
      host, path);

  /* zXg̏擾 */
  servhost = gethostbyname(host);
  if (servhost == NULL) {
    fprintf(stderr, "\"%s\"IPւ̕ϊɎs܂.\n", host);
    return 1;
  }

  /* \̂[NA */
  memset((void *) &server, 0, sizeof(server));

  server.sin_family = AF_INET;

  /* IPAhX\̂Rs[ */
  memcpy((void *) &server.sin_addr, (const void *) servhost->h_addr,
      (size_t) servhost->h_length);

  /* |[gԍw肳Ă */
  if (port != 0) {
    server.sin_port = htons(port);
  } else {
    /* getservbynameŃ|[gԍ擾 */
    service = getservbyname("http", "tcp");
    if (service != NULL) {
      server.sin_port = service->s_port;
    } else {
      server.sin_port = htons(80);
    }
  }

  /* \Pbg */
  if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf(stderr, "socketɎs܂.\n");
    return 1;
  }

  /* ڑ */
  if (connect(s, (struct sockaddr *) &server, sizeof(server)) == -1) {
    fprintf(stderr, "ڑɎs܂.\n");
    return 1;
  }

  /* HTTPvgR & T[oɑM */

  sprintf(send_buf, "GET %s HTTP/1.0\r\n", path);
  fprintf(stderr, "GET %s HTTP/1.0\n", path);
  send(s, send_buf, (int) strlen(send_buf), 0);

  sprintf(send_buf, "Host: %s:%d\r\n", host, port);
  fprintf(stderr, "Host: %s:%d\n", host, port);
  send(s, send_buf, (int) strlen(send_buf), 0);

  sprintf(send_buf, "\r\n");
  send(s, send_buf, (int) strlen(send_buf), 0);

  fflush(stderr);

  /* HTMLt@C擾 */
  /* flagFȂoutput_filename͎Ŏ擾 */
  /* flagTȂoutput_filename͎w肳ꂽ */

  if (flag == F) {
    len = strlen(url);

    if (url[len - 1] == '/') {
      strcpy(output_filename, "index.html");
    } else {

      for (i = len - 1; i >= 0; i--) {
	if (url[i] == '/') {
	  break;
	}
      }

      if ((url[i - 1] == '/') && (url[i - 2] == ':')) {
	strcpy(output_filename, "index.html");
      } else {
	strcpy(output_filename, &url[i + 1]);
      }
    }
  }

  /* t@CI[v */
  if ((fp = fopen(output_filename, "w")) == NULL) {
    perror(output_filename);
    return 1;
  }


  /* Măt@C֗Ƃ */

  for (;;) {
    read_size = recv(s, buf, MAX_CHAR, 0);

    for (i = 0; i < read_size; i++) {
      /* wb_tB[hIȂ */
      if ((buf[i] == '\n') && (buf[i - 1] == '\r') &&
	  (buf[i - 2] == '\n') && (buf[i - 3] == '\r')) {
	strcpy(buf2, &buf[i + 1]);
	buf[i + 1] = '\0';
	fwrite(buf, (size_t) (i + 1), 1, stderr);
	fflush(stderr);
	fwrite(buf2, (size_t) (read_size - (i + 1)), 1, fp);
	break;
      }
    }

    if (i != read_size) {
      break;
    } else {
      for (i = 0; i < read_size; i++) {
	if (buf[i] == ':')
	  break;
      }
      if (i != read_size) {
	fwrite(buf, (size_t) read_size, 1, stderr);
	fflush(stderr);
      } else {
	fwrite(buf, (size_t) read_size, 1, fp);
	break;
      }
    }

  }

  for (;;) {
    read_size = recv(s, buf, MAX_CHAR, 0);

    if (read_size > 0) {
      fwrite(buf, (size_t) read_size, 1, fp);
    } else {
      break;
    }
  }

  fclose(fp);

  /* \PbgN[Y */
#ifdef WIN32
  closesocket(s);
#else
  close(s);
#endif

  return 0;
}
